/* cryptoki.h include file for PKCS #11. */
/* $Revision: 1.4 $ */

/* License to copy and use this software is granted provided that it is
 * identified as "RSA Security Inc. PKCS #11 Cryptographic Token Interface
 * (Cryptoki)" in all material mentioning or referencing this software.
 * License is also granted to make and use derivative works provided that
 * such works are identified as "derived from the RSA Security Inc. PKCS #11
 * Cryptographic Token Interface (Cryptoki)" in all material mentioning or 
 * referencing the derived work.
 * RSA Security Inc. makes no representations concerning either the 
 * merchantability of this software or the suitability of this software for
 * any particular purpose. It is provided "as is" without express or implied
 * warranty of any kind.
 */

#ifndef  _CRYPTOKI_H
#define  _CRYPTOKI_H

// #pragma ident "@(#)cryptoki.h 1.2 05/06/08 SMI"

#ifdef  __cplusplus
extern "C" {
#endif


#ifdef _WIN32
#define LS_PKCS11_API __declspec(dllexport)
#else
#define LS_PKCS11_API
#endif // #ifdef _WIN32


#ifndef  CK_PTR
#define  CK_PTR *
#endif

#ifndef CK_DEFINE_FUNCTION
#define  CK_DEFINE_FUNCTION(returnType, name) returnType name
#endif

#ifndef CK_DECLARE_FUNCTION
#define  CK_DECLARE_FUNCTION(returnType, name) LS_PKCS11_API returnType name
#endif

#ifndef CK_DECLARE_FUNCTION_POINTER
#define  CK_DECLARE_FUNCTION_POINTER(returnType, name) returnType (* name)
#endif

#ifndef CK_CALLBACK_FUNCTION
#define  CK_CALLBACK_FUNCTION(returnType, name) returnType (* name)
#endif

#ifndef NULL_PTR
#ifndef _WIN32
#include <unistd.h>             /* For NULL */
#endif
#define  NULL_PTR NULL
#endif

    /*
     * pkcs11t.h defines TRUE and FALSE in a way that upsets lint
     */
#ifndef  CK_DISABLE_TRUE_FALSE
#define  CK_DISABLE_TRUE_FALSE
#ifndef  TRUE
#define  TRUE  1
#endif                          /* TRUE */
#ifndef  FALSE
#define  FALSE  0
#endif                          /* FALSE */
#endif                          /* CK_DISABLE_TRUE_FALSE */

#undef CK_PKCS11_FUNCTION_INFO

#include "pkcs11.h"

    /* Solaris specific functions */

#include <stdlib.h>

    /*
     * SUNW_C_GetMechSession will initialize the framework and do all
     * the necessary PKCS#11 calls to create a session capable of
     * providing operations on the requested mechanism
     */
    CK_RV SUNW_C_GetMechSession(CK_MECHANISM_TYPE mech,
                                CK_SESSION_HANDLE_PTR hSession);

    /*
     * SUNW_C_KeyToObject will create a secret key object for the given
     * mechanism from the rawkey data.
     */
    CK_RV SUNW_C_KeyToObject(CK_SESSION_HANDLE hSession,
                             CK_MECHANISM_TYPE mech, const void *rawkey,
                             size_t rawkey_len, CK_OBJECT_HANDLE_PTR obj);


#ifdef  __cplusplus
}
#endif
#endif                          /* _CRYPTOKI_H */
